﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using CalcEngine.Phrase;
using CalcEngine;

namespace TestProject1
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class PhraseAnalyzerTest
    {
        public PhraseAnalyzerTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestCalculationExpression1()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1+2+3=", phrases);

            
            Assert.AreEqual(5,phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);
            Assert.AreEqual(PhraseType.plus, phrases[3].Value);
            Assert.AreEqual(PhraseType.number, phrases[4].Value);

            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("2", phrases[2].Key);
            Assert.AreEqual("+", phrases[3].Key);
            Assert.AreEqual("3", phrases[4].Key);
        }

        [TestMethod]
        public void TestCalculationExpression2()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1.1+2.20+3=", phrases);
            
            Assert.AreEqual(5, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);
            Assert.AreEqual(PhraseType.plus, phrases[3].Value);
            Assert.AreEqual(PhraseType.number, phrases[4].Value);

            Assert.AreEqual("1.1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("2.20", phrases[2].Key);
            Assert.AreEqual("+", phrases[3].Key);
            Assert.AreEqual("3", phrases[4].Key);
        }
        [TestMethod]
        public void TestCalculationExpression3()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1.1+2.20++3=", phrases);
            

            Assert.AreEqual(6, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);
            Assert.AreEqual(PhraseType.plus, phrases[3].Value);
            Assert.AreEqual(PhraseType.plus, phrases[4].Value);
            Assert.AreEqual(PhraseType.number, phrases[5].Value);

            Assert.AreEqual("1.1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("2.20", phrases[2].Key);
            Assert.AreEqual("+", phrases[3].Key);
            Assert.AreEqual("+", phrases[4].Key);
            Assert.AreEqual("3", phrases[5].Key);

        }
        [TestMethod]
        public void TestCalculationExpression4()
        {
            PhraseStorage phrases = new PhraseStorage();
            try
            {
                PhraseAnalyzer.Analyze("1.1.1+1=", phrases);
            }
            catch(PhraseException e)
            {
                Assert.IsTrue(e.Message.Contains("Unrecognizable symbol"));
            }
        }
        [TestMethod]
        public void TestCalculationExpression5()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("sincos1=", phrases);
            

            Assert.AreEqual(3, phrases.Length);
            Assert.AreEqual(PhraseType.sin, phrases[0].Value);
            Assert.AreEqual(PhraseType.cos, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);

            Assert.AreEqual("sin", phrases[0].Key);
            Assert.AreEqual("cos", phrases[1].Key);
            Assert.AreEqual("1", phrases[2].Key);
        }
        [TestMethod]
        public void TestCalculationExpression6()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("cos(1+2*3-4)/5=", phrases);
            

            Assert.AreEqual(12, phrases.Length);
            Assert.AreEqual(PhraseType.cos, phrases[0].Value);
            Assert.AreEqual(PhraseType.leftbracket, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);
            Assert.AreEqual(PhraseType.plus, phrases[3].Value);
            Assert.AreEqual(PhraseType.number, phrases[4].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[5].Value);
            Assert.AreEqual(PhraseType.number, phrases[6].Value);
            Assert.AreEqual(PhraseType.minus, phrases[7].Value);
            Assert.AreEqual(PhraseType.number, phrases[8].Value);
            Assert.AreEqual(PhraseType.rightbracket, phrases[9].Value);
            Assert.AreEqual(PhraseType.divide, phrases[10].Value);
            Assert.AreEqual(PhraseType.number, phrases[11].Value);

            Assert.AreEqual("cos", phrases[0].Key);
            Assert.AreEqual("(", phrases[1].Key);
            Assert.AreEqual("1", phrases[2].Key);
            Assert.AreEqual("+", phrases[3].Key);
            Assert.AreEqual("2", phrases[4].Key);
            Assert.AreEqual("*", phrases[5].Key);
            Assert.AreEqual("3", phrases[6].Key);
            Assert.AreEqual("-", phrases[7].Key);
            Assert.AreEqual("4", phrases[8].Key);
            Assert.AreEqual(")", phrases[9].Key);
            Assert.AreEqual("/", phrases[10].Key);
            Assert.AreEqual("5", phrases[11].Key);
        }
        [TestMethod]
        public void TestCalculationExpression7()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("30!/50*sin30=", phrases);
            //

            Assert.AreEqual(7, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.fact, phrases[1].Value);
            Assert.AreEqual(PhraseType.divide, phrases[2].Value);
            Assert.AreEqual(PhraseType.number, phrases[3].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[4].Value);
            Assert.AreEqual(PhraseType.sin, phrases[5].Value);
            Assert.AreEqual(PhraseType.number, phrases[6].Value);
            
            Assert.AreEqual("30", phrases[0].Key);
            Assert.AreEqual("!", phrases[1].Key);
            Assert.AreEqual("/", phrases[2].Key);
            Assert.AreEqual("50", phrases[3].Key);
            Assert.AreEqual("*", phrases[4].Key);
            Assert.AreEqual("sin", phrases[5].Key);
            Assert.AreEqual("30", phrases[6].Key);
        }
        [TestMethod]
        public void TestCalculationExpression8()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("50-10*lg70=", phrases);

            Assert.AreEqual(6, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.minus, phrases[1].Value);
            Assert.AreEqual(PhraseType.number, phrases[2].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[3].Value);
            Assert.AreEqual(PhraseType.lg, phrases[4].Value);
            Assert.AreEqual(PhraseType.number, phrases[5].Value);

            Assert.AreEqual("50", phrases[0].Key);
            Assert.AreEqual("-", phrases[1].Key);
            Assert.AreEqual("10", phrases[2].Key);
            Assert.AreEqual("*", phrases[3].Key);
            Assert.AreEqual("lg", phrases[4].Key);
            Assert.AreEqual("70", phrases[5].Key);
        }
        [TestMethod]
        public void TestCalculationExpression9()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1/tg180*sin60=", phrases);

            Assert.AreEqual(7, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.divide, phrases[1].Value);
            Assert.AreEqual(PhraseType.tg, phrases[2].Value);
            Assert.AreEqual(PhraseType.number, phrases[3].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[4].Value);
            Assert.AreEqual(PhraseType.sin, phrases[5].Value);
            Assert.AreEqual(PhraseType.number, phrases[6].Value);

            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("/", phrases[1].Key);
            Assert.AreEqual("tg", phrases[2].Key);
            Assert.AreEqual("180", phrases[3].Key);
            Assert.AreEqual("*", phrases[4].Key);
            Assert.AreEqual("sin", phrases[5].Key);
            Assert.AreEqual("60", phrases[6].Key);
        }
        [TestMethod]
        public void TestCalculationExpression10()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1/sbrt5%2+-3=", phrases);

            Assert.AreEqual(9, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.divide, phrases[1].Value);
            Assert.AreEqual(PhraseType.sbrt, phrases[2].Value);
            Assert.AreEqual(PhraseType.number, phrases[3].Value);
            Assert.AreEqual(PhraseType.mod, phrases[4].Value);
            Assert.AreEqual(PhraseType.number, phrases[5].Value);
            Assert.AreEqual(PhraseType.plus, phrases[6].Value);
            Assert.AreEqual(PhraseType.negative, phrases[7].Value);
            Assert.AreEqual(PhraseType.number, phrases[8].Value);

            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("/", phrases[1].Key);
            Assert.AreEqual("sbrt", phrases[2].Key);
            Assert.AreEqual("5", phrases[3].Key);
            Assert.AreEqual("%", phrases[4].Key);
            Assert.AreEqual("2", phrases[5].Key);
            Assert.AreEqual("+", phrases[6].Key);
            Assert.AreEqual("3", phrases[8].Key);
        }
        [TestMethod]
        public void TestCalculationExpressionWithVariable1()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1+[abc]*2=", phrases);

            Assert.AreEqual(5, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.variable, phrases[2].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[3].Value);
            Assert.AreEqual(PhraseType.number, phrases[4].Value);

            
            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("abc", phrases[2].Key);
            Assert.AreEqual("*", phrases[3].Key);
            Assert.AreEqual("2", phrases[4].Key);
        }
        [TestMethod]
        public void TestCalculationExpressionWithVariable2()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1+[a_bc]/2=", phrases);

            Assert.AreEqual(5, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.variable, phrases[2].Value);
            Assert.AreEqual(PhraseType.divide, phrases[3].Value);
            Assert.AreEqual(PhraseType.number, phrases[4].Value);

            
            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("a_bc", phrases[2].Key);
            Assert.AreEqual("/", phrases[3].Key);
            Assert.AreEqual("2", phrases[4].Key);
        }
        [TestMethod]
        public void TestCalculationExpressionWithDataProvider1()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1+[data1:abc]*2=", phrases);

            Assert.AreEqual(6, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.dataprovider, phrases[2].Value);
            Assert.AreEqual(PhraseType.fieldname, phrases[3].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[4].Value);
            Assert.AreEqual(PhraseType.number, phrases[5].Value);

            
            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("data1", phrases[2].Key);
            Assert.AreEqual("abc", phrases[3].Key);
            Assert.AreEqual("*", phrases[4].Key);
            Assert.AreEqual("2", phrases[5].Key);
        }
        [TestMethod]
        public void TestCalculationExpressionWithDataProvider2()
        {
            PhraseStorage phrases = new PhraseStorage();
            PhraseAnalyzer.Analyze("1+[dat_a1:a_b2c_5]*2=", phrases);

            Assert.AreEqual(6, phrases.Length);
            Assert.AreEqual(PhraseType.number, phrases[0].Value);
            Assert.AreEqual(PhraseType.plus, phrases[1].Value);
            Assert.AreEqual(PhraseType.dataprovider, phrases[2].Value);
            Assert.AreEqual(PhraseType.fieldname, phrases[3].Value);
            Assert.AreEqual(PhraseType.mutiple, phrases[4].Value);
            Assert.AreEqual(PhraseType.number, phrases[5].Value);

            
            Assert.AreEqual("1", phrases[0].Key);
            Assert.AreEqual("+", phrases[1].Key);
            Assert.AreEqual("dat_a1", phrases[2].Key);
            Assert.AreEqual("a_b2c_5", phrases[3].Key);
            Assert.AreEqual("*", phrases[4].Key);
            Assert.AreEqual("2", phrases[5].Key);
        }
        [TestMethod]
        public void TestStringToType()
        {
            Assert.AreEqual(PhraseType.cos,PhraseAnalyzer.StrToType("cos"));
            Assert.AreEqual(PhraseType.sin, PhraseAnalyzer.StrToType("sin"));
            Assert.AreEqual(PhraseType.tg, PhraseAnalyzer.StrToType("tg"));
            Assert.AreEqual(PhraseType.ctg, PhraseAnalyzer.StrToType("ctg"));
            Assert.AreEqual(PhraseType.atg, PhraseAnalyzer.StrToType("atg"));
            Assert.AreEqual(PhraseType.actg, PhraseAnalyzer.StrToType("actg"));
            Assert.AreEqual(PhraseType.acos, PhraseAnalyzer.StrToType("acos"));
            Assert.AreEqual(PhraseType.asin, PhraseAnalyzer.StrToType("asin"));
            Assert.AreEqual(PhraseType.ln, PhraseAnalyzer.StrToType("ln"));
            Assert.AreEqual(PhraseType.lg, PhraseAnalyzer.StrToType("lg"));
            Assert.AreEqual(PhraseType.log, PhraseAnalyzer.StrToType("log"));
            Assert.AreEqual(PhraseType.leftbracket, PhraseAnalyzer.StrToType("("));
            Assert.AreEqual(PhraseType.rightbracket, PhraseAnalyzer.StrToType(")"));
            Assert.AreEqual(PhraseType.fact, PhraseAnalyzer.StrToType("!"));
            Assert.AreEqual(PhraseType.pow, PhraseAnalyzer.StrToType("^"));
            Assert.AreEqual(PhraseType.plus, PhraseAnalyzer.StrToType("+"));
            Assert.AreEqual(PhraseType.minus, PhraseAnalyzer.StrToType("-"));
            Assert.AreEqual(PhraseType.mutiple, PhraseAnalyzer.StrToType("*"));
            Assert.AreEqual(PhraseType.divide, PhraseAnalyzer.StrToType("/"));
            Assert.AreEqual(PhraseType.cbrt, PhraseAnalyzer.StrToType("cbrt"));
            Assert.AreEqual(PhraseType.sbrt, PhraseAnalyzer.StrToType("sbrt"));
        }
        [TestMethod]
        public void TestTypeToString()
        {
            Assert.AreEqual("cos", PhraseAnalyzer.TypeToStr(PhraseType.cos));
            Assert.AreEqual("sin", PhraseAnalyzer.TypeToStr(PhraseType.sin));
            Assert.AreEqual("tg", PhraseAnalyzer.TypeToStr(PhraseType.tg));
            Assert.AreEqual("ctg", PhraseAnalyzer.TypeToStr(PhraseType.ctg));
            Assert.AreEqual("atg", PhraseAnalyzer.TypeToStr(PhraseType.atg));
            Assert.AreEqual("actg", PhraseAnalyzer.TypeToStr(PhraseType.actg));
            Assert.AreEqual("acos", PhraseAnalyzer.TypeToStr(PhraseType.acos));
            Assert.AreEqual("asin", PhraseAnalyzer.TypeToStr(PhraseType.asin));
            Assert.AreEqual("ln", PhraseAnalyzer.TypeToStr(PhraseType.ln));
            Assert.AreEqual("lg", PhraseAnalyzer.TypeToStr(PhraseType.lg));
            Assert.AreEqual("log", PhraseAnalyzer.TypeToStr(PhraseType.log));
            Assert.AreEqual("(", PhraseAnalyzer.TypeToStr(PhraseType.leftbracket));
            Assert.AreEqual(")", PhraseAnalyzer.TypeToStr(PhraseType.rightbracket));
            Assert.AreEqual("!", PhraseAnalyzer.TypeToStr(PhraseType.fact));
            Assert.AreEqual("^", PhraseAnalyzer.TypeToStr(PhraseType.pow));
            Assert.AreEqual("+", PhraseAnalyzer.TypeToStr(PhraseType.plus));
            Assert.AreEqual("-", PhraseAnalyzer.TypeToStr(PhraseType.minus));
            Assert.AreEqual("*", PhraseAnalyzer.TypeToStr(PhraseType.mutiple));
            Assert.AreEqual("/", PhraseAnalyzer.TypeToStr(PhraseType.divide));
            Assert.AreEqual("cbrt", PhraseAnalyzer.TypeToStr(PhraseType.cbrt));
            Assert.AreEqual("sbrt", PhraseAnalyzer.TypeToStr(PhraseType.sbrt));
        }
    }
}

