#region BluePrint.Calculator, Copyright 2005 BluePrint Work Group, Programmed by Tony Qu
/* ************************************************************
 Ŀƣѧ
 ʵԣC#
 ߣTony Qu
 ߲ͣhttp://www.cnblogs.com/tonyqus
 ģƣʷ
 ģռ䣺PhraseAnalyzer
 ǰļϢPhraseAnalyzer.PhraseAnalyzerʷ
 Ŀǰ汾1.0.1.3
 
 ǰļ޶  
	Who			Date			Version			Comment
	Tony Qu		2005.4.15		1.0.0.0			ɻʷ
	Tony Qu		2005.5.13		1.0.1.0			ַ޶ָֻΧڵַͨ
	Tony Qu		2005.5.23		1.0.1.2			ʶpi,eΪPhraseType.number
												˱xַ򣬸AΪAX
												ln,lg,logʶ֧
												ոֺ޷ʶ
    Tony Qu		2006.8.5		1.0.1.3		    ֧ʶ@еĸŻᱻ滻Ϊ@
    Tony Qu     2007.12.16      1.0.1.4         bug 001:޷ex
*************************************************************/
#endregion

using System;
using System.Collections;
using System.Collections.Specialized;
using System.Globalization;

namespace PhraseAnalyzer
{
    /// <summary>
    /// ʷ
    /// </summary>
	public class PhraseAnalyzer
	{
        private DFAState _prestate;			//DFAǰһ״̬
        private char[] _chArray = null;		//ӱַʽ
        private string _sentence = null;		//ӱ
		private PhraseStorage _ps=null;
		private bool _succeed=true;

		public PhraseAnalyzer(string sentence,ref PhraseStorage ps)
		{
            //ǰһεĴʷ
            _ps = ps;
            _ps.ClearResult();
            //
            _sentence = sentence;
            _succeed = true;
            //Сдеĸ
            _chArray = sentence.ToLower().ToCharArray();
            if (Analyze() == false)	//
                _ps.AddPhraseResult("Error", PhraseType.unknown);
		}
        /// <summary>
        /// Ƿɹ
        /// </summary>
        public bool Succeed
        {
            get
            {
                return _succeed;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="startpos">ʼλ</param>
        /// <param name="endpos">λ</param>
		private void SavePhrase(int startpos,int endpos)
		{
			string temp=null;
            //'@'
            if (startpos == endpos && _chArray[startpos] == '@')
            {
                _ps.AddPhraseResult("@", PhraseType.negative);
                return;
            }
            //Ԫ
			if(endpos>=0 && startpos>=0 && endpos>=startpos)
			{
                //trim()Էֹstartposendposͷβֿո
				temp=_sentence.Substring(startpos,endpos-startpos+1).Trim().ToLower();
				_ps.AddPhraseResult(temp,PhraseAnalyzer.StrToType(temp));
			}
		}
        /// <summary>
        /// תַΪӦĴ
        /// </summary>
        /// <param name="str">ַ</param>
        /// <returns></returns>
		public static PhraseType StrToType(string str)
		{
			switch(str)
			{
				case "sin": return PhraseType.sin;
				case "cos": return PhraseType.cos;
				case "ln": return PhraseType.ln;
				case "lg": return PhraseType.lg;
				case "log": return PhraseType.log;
				case "^": return PhraseType.pow;
				case "cbrt": return PhraseType.cbrt;
				case "sbrt": return PhraseType.sbrt;
				case "asin": return PhraseType.asin;
				case "acos": return PhraseType.acos;
				case "!": return PhraseType.fact;
				case "tg": return PhraseType.tg;
				case "ctg": return PhraseType.ctg;
				case "atg":return PhraseType.atg;
				case "actg":return PhraseType.actg;
				case "+":return PhraseType.plus;
				case "-":return PhraseType.minus;
				case "*":return PhraseType.mutiple;
				case "/":return PhraseType.divide;
				case "%":return PhraseType.mod;
				case "(":return PhraseType.leftbracket;
				case ")":return PhraseType.rightbracket;
				case "#":return PhraseType.sharp;
				case "ans":return PhraseType.ans;
				case "sto":return PhraseType.sto;
				case "clr":return PhraseType.clr;
				case "ax": return PhraseType.ax;
				case "bx": return PhraseType.bx;
				case "cx": return PhraseType.cx;
				case "dx": return PhraseType.dx;
				case "ex": return PhraseType.ex;
				case "fx": return PhraseType.fx;
				case "e": return PhraseType.e;
				case "pi": return PhraseType.pi;
                case "@": return PhraseType.negative;
				default: return PhraseType.number;
			}
		}
        /// <summary>
        /// ַͼ
        /// </summary>
        /// <param name="startpos">ַʼλ</param>
        /// <param name="endpos">ַλ</param>
        /// <returns>ַǷƥ涨Χݵ</returns>
		private bool CheckString(int startpos,int endpos)
		{
            //trim()Էֹstartposendposͷβֿո
			string temp=this._sentence.Substring(startpos,endpos-startpos+1).Trim().ToLower();
            int len = temp.Length;	//temp.lengthһendpos-startpos+1
			if(len==1)
			{
				switch(temp)
				{
					case "e":
                        //BUGFIX:ex
                        //һַΪxΪex
                        if(_chArray.Length>endpos+1&&_chArray[endpos+1]=='x')
                        {
                            return false;
                        }
						return true;
				}
			}
			else if(len==2)
			{
				switch(temp)
				{
					case "ln":
					case "lg":
					case "tg":
					case "ax":
					case "bx":
					case "cx":
					case "dx":
					case "ex":
					case "fx":
					case "pi":
						return true;
				}
			}
			else if(len==3)
			{
				switch(temp)
				{
					case "cos":
					case "sin":
					case "ctg":
					case "atg":
					case "ans":
					case "clr":
					case "sto":
					case "log":
						return true;
				}
			}
			else if(len==4)
			{
				switch(temp)
				{
					case "acos":
					case "asin":
					case "actg":
					case "sbrt":
					case "cbrt":
						return true;
				}
			}
			return false;
		}
        /// <summary>
        /// ʷ
        /// </summary>
        /// <returns>Ƿɹ</returns>
		private bool Analyze()
		{
            int i = 0;
            int startpos = 0, endpos = 0;
            //ó̬
            _prestate = DFAState.S0;
            while (i < _chArray.Length)
            {
                //δ֪̬
                if (_prestate == DFAState.SX)
                {
                    _succeed = false;
                    return false;
                }

                if (Char.IsLetter(_chArray[i]))
                {
                    //ĸ
                    if (_prestate == DFAState.S0)
                    {
                        //̬ĸ
                        _prestate = DFAState.S3;
                    }
                    else if (_prestate != DFAState.S3)
                    {
                        //ǰһ
                        endpos = i - 1;	//λ
                        SavePhrase(startpos, endpos);
                        //ĸתΪĸ
                        _prestate = DFAState.S3;
                        //濪ʼλ
                        startpos = i;
                    }
                    else	//֮ǰ״̬ΪĸDFAState.S3
                    {

                        endpos = i - 1;	//λ

                        //ĸƥ
                        if (CheckString(startpos, endpos) == true)
                        {
                            SavePhrase(startpos, endpos);
                            startpos = i;
                        }
                    }
                }
                else if (Char.IsDigit(_chArray[i]))
                {
                    //
                    if (_prestate == DFAState.S0)
                    {
                        //̬
                        _prestate = DFAState.S1;
                        startpos = i;	//濪ʼλ
                    }
                    else if (_prestate == DFAState.S1)
                    {
                        //״̬
                    }
                    else if (_prestate == DFAState.S2)	//
                        _prestate = DFAState.S2;
                    else
                    {
                        //ǰһ
                        endpos = i - 1;	//λ
                        //ַͼ
                        if (_prestate == DFAState.S3 && CheckString(startpos,endpos) == false)
                            return false;	//ǰһ״̬Ϊַַ̬ƥʧܣ˳
                        else
                            SavePhrase(startpos, endpos);

                        //ӷִתΪ
                        _prestate = DFAState.S1;
                        //濪ʼλ
                        startpos = i;
                    }
                }
                else if (_chArray[i] == '.')
                {
                    //С
                    if (_prestate == DFAState.S1 || _prestate == DFAState.S0)
                        _prestate = DFAState.S2;	//̬Ϊ
                    else
                    {	//δ֪̬
                        // Ҫ: Ƿ񱣴ǰһ
                        _prestate = DFAState.SX;
                    }
                }
                else if (Char.IsWhiteSpace(_chArray[i]))
                {
                    //ո
                }
                else if (_chArray[i] == '+' || _chArray[i] == '-' || _chArray[i] == '*' || _chArray[i] == '/' || _chArray[i] == '^' || _chArray[i] == '%' || _chArray[i] == '(' || _chArray[i] == ')' || _chArray[i] == '!' || _chArray[i] == '#' || _chArray[i] == '@' || _chArray[i] == '=')
				{
                    if (_prestate != DFAState.S0)
                    {
                        //ǰһ
                        endpos = i - 1;
                        //ַͼ
                        if (_prestate == DFAState.S3 && CheckString(startpos,endpos) == false)
                            return false;	//ǰһ״̬Ϊַַ̬ƥʧܣ˳
                        else
                            SavePhrase(startpos, endpos);
                    }
                    if (_chArray[i] == '-')
                    {
                        if (_ps.PhraseTypeResult.Length > 0)
                        {
                            PhraseType prept = _ps.PhraseTypeResult[_ps.PhraseTypeResult.Length - 1];
                            if (prept != PhraseType.ax && prept != PhraseType.bx && prept != PhraseType.cx&& prept != PhraseType.dx && prept != PhraseType.ex && prept != PhraseType.fx && prept != PhraseType.clr && prept != PhraseType.sto&& prept != PhraseType.rightbracket&&prept!=PhraseType.number)
                            {
                                _chArray[i] = '@';
                            }
                        }
                        else
                        {
                            _chArray[i] = '@';
                        }
                    }
					if(_chArray[i]=='+')
						_prestate=DFAState.S4;
                    else if (_chArray[i] == '-')
                    {
                        _prestate = DFAState.S5;
                    }
                    else if (_chArray[i] == '*')
                        _prestate = DFAState.S6;
                    else if (_chArray[i] == '/')
                        _prestate = DFAState.S7;
                    else if (_chArray[i] == '=')     //not support so far
                        _prestate = DFAState.S11;
                    else if (_chArray[i] == '%')
                        _prestate = DFAState.S8;
                    else if (_chArray[i] == '^')
                        _prestate = DFAState.S10;
                    else if (_chArray[i] == '(')
                        _prestate = DFAState.S12;
                    else if (_chArray[i] == ')')
                        _prestate = DFAState.S13;
                    else if (_chArray[i] == '!')
                        _prestate = DFAState.S9;
                    else if (_chArray[i] == '#')
                        _prestate = DFAState.S14;
                    else if (_chArray[i] == '@')
                        _prestate = DFAState.S15;

                    //濪ʼλ
                    startpos = i;
				}
				else
				{
                    //δַ֪δ֪̬
					_prestate=DFAState.SX;
				}
				i++;
			}
			return true;
		}
	}
}
